/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2008 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.tools.webadmin.ui.channelclient.exception;

import org.ow2.petals.tools.webadmin.datacollector.exception.DataCollectorException;

/**
 * Deals with all web channel client exceptions
 * 
 * @author mcarpentier - EBM WebSourcing
 * 
 */
public class WebConsoleChannelClientException extends DataCollectorException {

    private static final long serialVersionUID = 1L;

    public WebConsoleChannelClientException() {
        super();
    }

    /**
     * @param message
     *            the raw message explaining the cause of the error
     */
    public WebConsoleChannelClientException(String message) {
        super(message);
    }

    /**
     * @param message
     *            the raw message explaining the cause of the error
     * @param e
     *            the exception
     */
    public WebConsoleChannelClientException(String message, Throwable e) {
        super(message, e);
    }

    /**
     * @param e
     *            the exception
     */
    public WebConsoleChannelClientException(Throwable e) {
        super(e);
    }

}
