/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.tools.webadmin.ui.infra.bean;

import org.ow2.petals.tools.webadmin.util.StringHelper;

/**
 * used to store and display any message (error, warning, info)
 * 
 * @author mcarpentier - EBM Websourcing
 *
 */
public class InfoBean {
    public static int NO_MESSAGE = -1;
    public static int ERROR_MESSAGE = 0;
    public static int WARNING_MESSAGE = 1;
    public static int INFO_MESSAGE = 2;
    public static int SUCCESS_MESSAGE = 2;
      
    public static String ERROR_STRING = "error";
    public static String WARNING_STRING = "warning";
    public static String INFO_STRING = "info";
    public static String SUCCESS_STRING = "success";
       
    private String message;

    private int messageType;

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public int getMessageType() {
        return messageType;
    }

    public void setMessageType(int messageType) {
        this.messageType = messageType;
    }
    
    public void reset() {
        this.setMessage("");
        this.setMessageType(-1);
    }
    
    public boolean hasInfo() {
        return ((StringHelper.isNotNullAndNotEmpty(this.message)) && (this.messageType != -1));
    }

}
