/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.ow2.petals.tools.webadmin.ui.infra.session;

import org.ow2.petals.tools.webadmin.util.StringHelper;

/**
 * classic user bean
 * 
 * @author mcarpentier  - EBM Websourcing
 *
 */
public class WebUser {
    
    public final static String ADMIN_ROLE="admin";
    public final static String MONITORING_ROLE="monitoring";

    private String login;
    private String firstName;
    private String lastname;
    private String mail;
    private String password;
    private boolean admin=false;
    private boolean monitoring=false;
    
    public WebUser() {
        super();
    }
    
    public void setRoles(String roles) {
        if (StringHelper.isNotNullAndNotEmpty(roles)) {
           if (roles.indexOf(WebUser.ADMIN_ROLE) != -1) {
                setAdmin(true);
            }
           if (roles.indexOf(WebUser.MONITORING_ROLE) != -1) {
              setMonitoring(true); 
           }
        }
    }
    
    public WebUser(String login) {
        this.login=login;
    }
    
    public String getFirstName() {
        return firstName;
    }
    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }
    public String getLastname() {
        return lastname;
    }
    public void setLastname(String lastname) {
        this.lastname = lastname;
    }
    public String getLogin() {
        return login;
    }
    public void setLogin(String login) {
        this.login = login;
    }
    public String getMail() {
        return mail;
    }
    public void setMail(String mail) {
        this.mail = mail;
    }
    public String getPassword() {
        return password;
    }
    public void setPassword(String password) {
        this.password = password;
    }

    public boolean isAdmin() {
        return admin;
    }

    public void setAdmin(boolean admin) {
        this.admin = admin;
    }

    public boolean isMonitoring() {
        return monitoring;
    }

    public void setMonitoring(boolean monitoring) {
        this.monitoring = monitoring;
    }
}
