/**
 * 
 */
package org.ow2.petals.tools.webadmin.ui.proxyservice;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.upload.FormFile;
import org.ow2.petals.tools.webadmin.ui.infra.session.AdminSession;
import org.ow2.petals.tools.webadmin.ui.portlet.ShowPortlet;
import org.ow2.petals.tools.webadmin.util.FilePermissionHelper;

/**
 * @author aruffie
 * 
 */
public class AddWsdl extends ProxyServiceAction {

    final Logger log = Logger.getLogger(ShowPortlet.class);

    private static final String actionTitle = "add Proxy Service";

    @Override
    public ActionForward executeProxyServiceActionAuthentified(ActionMapping iActionMapping,
            ActionForm iActionForm, HttpServletRequest iServletRequest,
            HttpServletResponse iServletResponse) throws Exception {
        // TODO Auto-generated method stub
        iServletRequest.setAttribute("errorWsdl", null);
        boolean errors = false;
        iServletRequest.setAttribute("errorWsdlFile", null);

        // Set the good factory for easywsdl
        System.setProperty("javax.xml.transform.TransformerFactory",
                "com.sun.org.apache.xalan.internal.xsltc.trax.TransformerFactoryImpl");
        AddWsdlForm form = (AddWsdlForm) iActionForm;
        AdminSession adminSession = AdminSession.getAdminSession(iServletRequest.getSession());

        /** set navigation info* */
        adminSession.setSelectedMenu(AdminSession.PROXY_SERVICE);

        String wsdl = null;

        FormFile file = null;
        if ((form.getTheFile() == null)||(form.getTheFile().getFileName().trim().equals(""))) {
            // add Message error if wsdl parameter null
            //iServletRequest.setAttribute("errorWsdl", true);
            //errors = true;
            iServletRequest.setAttribute("errorWsdlFile", true);;
            return iActionMapping.findForward("error");
        }

      //create repository and upload file
        final ServletContext context = iServletRequest.getSession().getServletContext();
        String reqPath = iServletRequest.getContextPath();
        reqPath = reqPath.substring(reqPath.lastIndexOf("/")+1);
        final String realContextPath = context.getRealPath(iServletRequest.getContextPath());
        final String rootPath = realContextPath.substring(0, realContextPath.lastIndexOf(reqPath));
        File uploadDir = new File(rootPath + "upload/");
       
        if(!(uploadDir.exists())){
            uploadDir.mkdir();
        }
        try {
            FilePermissionHelper.setRights(uploadDir,new int[] {7,7,7}, false);
        } catch (IOException e1) {
            iServletRequest.setAttribute("error", e1.getMessage());
            System.out.println("Exception occured in AddWsdl: " + e1.getMessage());
            return iActionMapping.findForward("error");
        }
        
        // Begin add the wsdl file in the repository
        file = form.getTheFile();
        wsdl = file.getFileName();
        
        File wsdlFile = new File(uploadDir.getCanonicalPath() + "/"
                + file.getFileName());
        if (!wsdlFile.exists()) {
            wsdlFile.createNewFile();
        }
        OutputStream writer = new FileOutputStream(wsdlFile);
        writer.write(file.getFileData());
        writer.flush();
        writer.close();
        // ending add the wsdl file in the repository

        // begin parse wsdl file with easy wsdl
        /*
         * Add all services found in WSDL File for display them to user, to
         * enable him to select the service/endpoint he wants to proxify
         */
        try {
            iServletRequest.setAttribute("wsdlServices", HandlerAddWsdl.getServices(wsdlFile));
        } catch (Exception e) {
            /*
             * if one error occured (file isn't wsdl type) don't save it in the
             * repository and show error to user
             */
            iServletRequest.setAttribute("errorWsdlFile", true);
            wsdlFile.delete();
            System.out.println("Exception occured for get the wsdl file: " + e.getMessage());
            return iActionMapping.findForward("error");
        }
        // end parse wsdl file with easy wsdl

        iServletRequest.getSession().setAttribute("wsdlFile", wsdl);
        return iActionMapping.findForward("success");

    }

}
