/**
 * 
 */
package org.ow2.petals.tools.webadmin.ui.proxyservice;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.net.UnknownHostException;
import java.util.Date;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;

import org.ow2.petals.tools.webadmin.cron.CollectorManager;
import org.ow2.petals.tools.webadmin.datacollector.client.exception.DataCollectorClientException;
import org.ow2.petals.tools.webadmin.datacollector.server.CollectorServer;
import org.ow2.petals.tools.webadmin.datacollector.server.exception.DataCollectorClientDoesNotExistException;
import org.ow2.petals.tools.webadmin.datacollector.server.exception.DataCollectorServerException;
import org.ow2.petals.tools.webadmin.datacollector.server.exception.DataCollectorServerNotInitializedException;
import org.ow2.petals.tools.webadmin.util.ArtifactInstallationHelper;
import org.ow2.petals.tools.webadmin.util.FilePermissionHelper;

/**
 * @author aruffie
 *
 */
public class ArtifactDeployer {

    public static String saDeployement(HttpServletRequest iServletRequest,
            File saFile, String serverName, String subdomain){
        // check if we use http or ftp download
        URI artifactServerURI = null;
        try{
            artifactServerURI = ArtifactInstallationHelper.getURI(iServletRequest);
        }catch (final URISyntaxException e){
            System.out.println("Exception occured durin getURI() in SA Deployement");
        }
        if("ftp".equalsIgnoreCase(artifactServerURI.getScheme())){
            return "Error: FTP artifact installation not supported yet";
            
        }else if ("http".equalsIgnoreCase(artifactServerURI.getScheme())){
            try{        
                if(serverName != null){
                    final CollectorServer collector = CollectorManager.getCollector();
                    
                    //constructs http url of file uploaded
                    final int lastSeparator = artifactServerURI.toString().lastIndexOf("/")+1;
                    URL httpUrl = new URL(artifactServerURI.toString().substring(0,lastSeparator)
                           +"upload/"+saFile.getName());                              
                  collector.getCollectorClient(serverName).getDeployService().deployServiceAssembly(httpUrl);
                }
            } catch (final IOException e) {              
                System.out.println("Error: "+e.getMessage());
                throw new RuntimeException("Error : SA archive file not readable - "+e.getMessage());
            } catch (final DataCollectorClientException e) {         
                System.out.println("Error: "+e.getMessage());
                throw new RuntimeException("Error :"+saFile.getName() +e.getMessage());     
            } catch (final DataCollectorServerException e) {
                System.out.println("Error: "+e.getMessage());
                throw new RuntimeException("Error :"+saFile.getName() +e.getMessage());
            } catch (DataCollectorClientDoesNotExistException e) {
                System.out.println("Error: "+e.getMessage());
                throw new RuntimeException("Error: Can't reach PEtALS client, your server list must be out of date - "+e.getMessage());
            } catch (final DataCollectorServerNotInitializedException e) {
                CollectorManager.resetCollector();
                System.out.println("Error: Connection to PEtALS lost, please refresh");
                throw new RuntimeException("Error: Connection to PEtALS lost, please refresh - "+e.getMessage());
            }
            
        }
        return null;
    }   
   
}
