/**
 * 
 */
package org.ow2.petals.tools.webadmin.ui.proxyservice;

import java.io.File;
import java.io.FileNotFoundException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.List;

import org.ow2.easywsdl.wsdl.WSDLFactory;
import org.ow2.easywsdl.wsdl.api.Description;
import org.ow2.easywsdl.wsdl.api.Service;
import org.ow2.easywsdl.wsdl.api.WSDLException;
import org.ow2.easywsdl.wsdl.api.WSDLReader;

/**
 * @author aruffie
 * 
 */
public class HandlerAddWsdl {

    /**
     * Return all services find in the wsdlFile provided
     * 
     * @param wsdlFile
     * @return
     * @throws FileNotFoundException
     */
    public static List<Service> getServices(File wsdlFile) throws FileNotFoundException {
        // TODO Auto-generated method stub
        Description description = null;
        try {
            description = getDescription(wsdlFile);
        } catch (WSDLException e) {
            // TODO Auto-generated catch block
            throw new RuntimeException("The file provided isn't a type of WSDL file: "+e.getMessage());
        } catch (URISyntaxException e) {
            // TODO Auto-generated catch block
            System.out.println("Exception occured in getServices: " + e.getMessage());
        }
        return description.getServices();

    }

    /**
     * Return the description of the wsdlFile provided
     * 
     * @param wsdlFile
     * @return
     * @throws WSDLException
     * @throws URISyntaxException
     * @throws FileNotFoundException
     */
    public static Description getDescription(File wsdlFile) throws WSDLException,
            URISyntaxException, FileNotFoundException {
        WSDLReader wsdlReader = null;
        try {
            wsdlReader = WSDLFactory.newInstance().newWSDLReader();
        } catch (WSDLException e) {
            // TODO Auto-generated catch block
            System.out.println("Exception occured during getDescription: " + e.getMessage());
        }

        return wsdlReader.readWSDL(new URI(wsdlFile.toURI().toString()));

    }

}
