package org.ow2.petals.tools.webadmin.ui.proxyservice;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.ow2.petals.tools.webadmin.ui.infra.action.AuthentifiedAction;
import org.ow2.petals.tools.webadmin.ui.infra.session.AdminSession;

public abstract class ProxyServiceAction extends AuthentifiedAction {

    @Override
    public ActionForward executeAuthentified(ActionMapping iActionMapping, ActionForm iActionForm,
            HttpServletRequest iServletRequest, HttpServletResponse iServletResponse)
            throws Exception {
        // --- check that user is logged in
        AdminSession session = AdminSession.getAdminSession(iServletRequest.getSession());

        /** Role check * */
        if (!session.getUser().isAdmin()) {
            return iActionMapping.findForward("forbidden");
        }

        return executeProxyServiceActionAuthentified(iActionMapping, iActionForm, iServletRequest,
                iServletResponse);
    }

    public abstract ActionForward executeProxyServiceActionAuthentified(
            ActionMapping iActionMapping, ActionForm iActionForm,
            HttpServletRequest iServletRequest, HttpServletResponse iServletResponse)
            throws Exception;
}
