package org.ow2.petals.tools.webadmin.ui.proxyservice;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.ow2.petals.tools.webadmin.ui.infra.bean.ContainerLVO;
import org.ow2.petals.tools.webadmin.ui.infra.bean.DomainLVO;
import org.ow2.petals.tools.webadmin.ui.infra.bean.SubdomainLVO;
import org.ow2.petals.tools.webadmin.ui.infra.session.AdminSession;

public class ShowProxyService extends ProxyServiceAction {

    private static final String actionTitle = "get PEtALS Proxy service";

    final Logger log = Logger.getLogger(ShowProxyService.class);

    @Override
    public ActionForward executeProxyServiceActionAuthentified(ActionMapping actionMapping,
            ActionForm actionForm, HttpServletRequest servletRequest,
            HttpServletResponse servletResponse) throws Exception {

        final AdminSession adminSession = AdminSession.getAdminSession(servletRequest.getSession());
        // TODO Auto-generated method stub
        /** set navigation info* */
        adminSession.setSelectedMenu(AdminSession.PROXY_SERVICE);

        // recover the domain
        DomainLVO dLVO = adminSession.getDomain();
        // set domain in the jsp for display all sub domain & server
        List<String> serverList = new ArrayList<String>();
        Iterator<SubdomainLVO> subIt = dLVO.getSubdomains().values().iterator();
        while (subIt.hasNext()) {
            SubdomainLVO subdLVO = subIt.next();
            Iterator<ContainerLVO> serverIt = subdLVO.getServers().iterator();
            while (serverIt.hasNext()) {
                ContainerLVO server = serverIt.next();
                serverList.add(dLVO.getName() + "." + subdLVO.getName() + ".server"
                        + server.getName());
            }
        }
        Iterator<String> testIt = serverList.iterator();
        servletRequest.setAttribute("domainForProxy", serverList);
        /*
         * Redirect old parameters in the new request
         */
        return actionMapping.findForward("success");
    }

}
